CREATE OR REPLACE FUNCTION APURA_DATA_PAGAMENTO(
   P_NRSEQUMAPAPU    IN MAPAAPURAC.NRSEQUMAPAPU%TYPE,
   P_CDEMPRESA       IN MAPAAPURAC.CDEMPRESA%TYPE,
   P_CDIMPOSTO       IN MAPAAPURAC.CDIMPOSTO%TYPE,
   P_INSCRICAO       IN MAPAAPURAC.CDINSCESTA%TYPE,
   P_DTFINAL         IN MAPAAPURAC.DTFIMPERIODO%TYPE,
   P_DTINICIAL       IN MAPAAPURAC.DTINIPERIODO%TYPE,
   P_BOIMPOSAPUR     IN BOOLEAN,
   P_IDORGARRECADNFE IN IMPOSTONFE.IDORGARRECADNFE%TYPE,
   P_DTININFFORPER   IN PARAMFISCAL.DTININFFORPER%TYPE,
   P_IDNFFORAPERAPU  IN IMPOSTO.IDNFFORAPERAPU%TYPE) RETURN VARCHAR
AS
   V_IDAPURACAO    VARCHAR2(01);
   V_NFFORAPERIODO VARCHAR2(01);
   V_IDCONSVRIMPAG VARCHAR2(01);
BEGIN
   BEGIN
      SELECT NVL(MAX(IDCONSVRIMPAG),'T') AS IDCONSVRIMPAG
        INTO V_IDCONSVRIMPAG
        FROM IMPOSTO
       WHERE CDIMPOSTONFE = P_CDIMPOSTO;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDCONSVRIMPAG := 'T';
   END;

   IF P_BOIMPOSAPUR THEN
      V_IDAPURACAO := 'B';

      /******** Considera o valor Total do imposto na primeira parcela paga - Dados na IMPOSTONF ********/
      IF V_IDCONSVRIMPAG = 'T' THEN

         UPDATE IMPOSTONF
            SET NRSEQMAPOIMP = P_NRSEQUMAPAPU
          WHERE NRSEQMAPOIMP IS NULL
            AND (CDFILIAL,NRLANCTONF,CDIMPOSTO) IN (SELECT DISTINCT N.CDFILIAL, N.NRLANCTONF, IP.CDIMPOSTO
                                                      FROM NOTAFISCAL N, CONTAPAGAR C, BOLETPAGAR B, BAIXAPAGA BX, IMPOSTONF IP
                                                     WHERE N.CDEMPRESA     = P_CDEMPRESA
                                                       AND N.IDSTATUS      IN ('A','E')
                                                       AND N.IDENTRSAIDOP  = 'E'
                                                       AND N.CDFILIAL      = C.CDFILIAL
                                                       AND N.NRLANCTONF    = C.NRLANCTONF
                                                       AND IP.CDFILIAL     = C.CDFILIAL
                                                       AND IP.NRLANCTONF   = C.NRLANCTONF
                                                       AND ((IP.CDIMPOSTO  IN (SELECT CDIMPOSTO FROM IMPOSTO
                                                                                WHERE CDIMPOSTONFE = P_CDIMPOSTO)) OR
                                                            (IP.CDIMPOSTO  IN (SELECT CDIMPOSTO FROM IMPOSTO
                                                                                WHERE CDIMPOSAPUR IN (SELECT CDIMPOSTO FROM IMPOSTO
                                                                                                       WHERE CDIMPOSTONFE = P_CDIMPOSTO))))
                                                       AND (((P_INSCRICAO IS NULL) AND (P_IDORGARRECADNFE = 'F' OR P_IDORGARRECADNFE IS NULL)) OR
                                                             (CDINSCESTA  = P_INSCRICAO AND P_IDORGARRECADNFE = 'E') OR
                                                             (CDINSCMUNI  = P_INSCRICAO AND P_IDORGARRECADNFE = 'M'))
                                                       AND C.CDFILIBPAG   = B.CDFILIAL
                                                       AND C.NRLANBOLPAG  = B.NRLANBOLPAG
                                                       AND B.CDFILIBAIPAG = BX.CDFILIAL
                                                       AND B.NRBAIXAPAG   = BX.NRBAIXAPAG
                                                       AND BX.CDEMPRESA   = P_CDEMPRESA
                                                       AND (((P_IDNFFORAPERAPU='N') AND (BX.DTBAIXAPAG BETWEEN P_DTININFFORPER AND P_DTFINAL)) OR
                                                            ((P_IDNFFORAPERAPU='S') AND (IP.DTREFMAPAPU IS NULL) AND (BX.DTBAIXAPAG BETWEEN P_DTININFFORPER AND P_DTFINAL)) OR
                                                            ((P_IDNFFORAPERAPU='S') AND (IP.DTREFMAPAPU BETWEEN P_DTINICIAL AND P_DTFINAL) AND (BX.DTBAIXAPAG BETWEEN P_DTININFFORPER AND P_DTFINAL))));

         UPDATE IMPOSTONF
            SET NRSEQMAPOIMP = P_NRSEQUMAPAPU
          WHERE NRSEQMAPOIMP IS NULL
            AND (CDFILIAL,NRLANCTONF,CDIMPOSTO) IN (SELECT DISTINCT N.CDFILIAL, N.NRLANCTONF, IP.CDIMPOSTO
                                                      FROM NOTAFISCAL N, CONTARECEBER C,BOLETRECEBER B,BAIXARECEBIDA BX, IMPOSTONF IP
                                                     WHERE N.CDEMPRESA     = P_CDEMPRESA
                                                       AND N.IDSTATUS      IN ('A','E')
                                                       AND N.IDENTRSAIDOP  = 'S'
                                                       AND N.CDFILIAL      = C.CDFILIAL
                                                       AND N.NRLANCTONF    = C.NRLANCTONF
                                                       AND IP.CDFILIAL     = C.CDFILIAL
                                                       AND IP.NRLANCTONF   = C.NRLANCTONF
                                                       AND ((IP.CDIMPOSTO  IN (SELECT CDIMPOSTO FROM IMPOSTO
                                                                                WHERE CDIMPOSTONFE = P_CDIMPOSTO)) OR
                                                            (IP.CDIMPOSTO  IN (SELECT CDIMPOSTO FROM IMPOSTO
                                                                                WHERE CDIMPOSAPUR IN (SELECT CDIMPOSTO FROM IMPOSTO
                                                                                                       WHERE CDIMPOSTONFE = P_CDIMPOSTO))))
                                                       AND (((P_INSCRICAO IS NULL)      AND (P_IDORGARRECADNFE = 'F'  OR P_IDORGARRECADNFE IS NULL)) OR
                                                             (CDINSCESTA  = P_INSCRICAO AND  P_IDORGARRECADNFE = 'E') OR
                                                             (CDINSCMUNI  = P_INSCRICAO AND  P_IDORGARRECADNFE = 'M'))
                                                       AND C.CDFILIBOLREC = B.CDFILIAL
                                                       AND C.NRLANBOLREC  = B.NRLANBOLREC
                                                       AND B.CDFILIBAIREC = BX.CDFILIAL
                                                       AND B.NRBAIXAREC   = BX.NRBAIXAREC
                                                       AND BX.CDEMPRESA   = P_CDEMPRESA
                                                       AND (((P_IDNFFORAPERAPU='N') AND (BX.DTBAIXAREC BETWEEN P_DTININFFORPER AND P_DTFINAL)) OR
                                                            ((P_IDNFFORAPERAPU='S') AND (IP.DTREFMAPAPU IS NULL) AND (BX.DTBAIXAREC BETWEEN P_DTININFFORPER AND P_DTFINAL)) OR
                                                            ((P_IDNFFORAPERAPU='S') AND (IP.DTREFMAPAPU BETWEEN P_DTINICIAL AND P_DTFINAL) AND (BX.DTBAIXAREC BETWEEN P_DTININFFORPER AND P_DTFINAL))));

      /******** Considera o valor do imposto proporcional ao valor da nota que foi pago - Dados na IMPBAIXAREC ********/
      ELSE
         UPDATE IMPBAIXAREC
            SET NRSEQMAPOIMP = P_NRSEQUMAPAPU
          WHERE NRSEQMAPOIMP IS NULL
            AND (CDFILIAL,NRLANCTONF,NRSEQUENCIAL,CDIMPOSTO) IN (SELECT DISTINCT N.CDFILIAL,N.NRLANCTONF,I.NRSEQUENCIAL,I.CDIMPOSTO
                                                                   FROM NOTAFISCAL N, IMPBAIXAREC I
                                                                  WHERE N.CDEMPRESA    = P_CDEMPRESA
                                                                    AND N.IDSTATUS     IN ('A','E')
                                                                    AND N.CDFILIAL     = I.CDFILIAL
                                                                    AND N.NRLANCTONF   = I.NRLANCTONF
                                                                    AND ((I.CDIMPOSTO  IN (SELECT CDIMPOSTO FROM IMPOSTO
                                                                                            WHERE CDIMPOSTONFE = P_CDIMPOSTO)) OR
                                                                         (I.CDIMPOSTO  IN (SELECT CDIMPOSTO FROM IMPOSTO
                                                                                            WHERE CDIMPOSAPUR IN (SELECT CDIMPOSTO FROM IMPOSTO
                                                                                                                   WHERE CDIMPOSTONFE = P_CDIMPOSTO))))
                                                                    AND (((P_INSCRICAO IS NULL) AND (P_IDORGARRECADNFE = 'F' OR P_IDORGARRECADNFE IS NULL)) OR
                                                                          (N.CDINSCESTA = P_INSCRICAO AND P_IDORGARRECADNFE = 'E') OR
                                                                          (N.CDINSCMUNI = P_INSCRICAO AND P_IDORGARRECADNFE = 'M'))
                                                                    AND (((P_IDNFFORAPERAPU='N') AND (I.DTBAIXAREC BETWEEN P_DTININFFORPER AND P_DTFINAL)) OR
                                                                         ((P_IDNFFORAPERAPU='S') AND (I.DTREFMAPAPU IS NULL) AND (I.DTBAIXAREC BETWEEN P_DTININFFORPER AND P_DTFINAL)) OR
                                                                         ((P_IDNFFORAPERAPU='S') AND (I.DTREFMAPAPU BETWEEN P_DTINICIAL AND P_DTFINAL) AND (I.DTBAIXAREC BETWEEN P_DTININFFORPER AND P_DTFINAL))));
      END IF;
   ELSE
      V_IDAPURACAO := 'V';

      /******** Considera o valor Total do imposto na primeira parcela paga - Dados na IMPOSTONF ********/
      IF V_IDCONSVRIMPAG = 'T' THEN

         UPDATE IMPOSTONF
            SET NRSEQUMAPAPU = P_NRSEQUMAPAPU
          WHERE NRSEQUMAPAPU IS NULL
            AND (CDFILIAL,NRLANCTONF,CDIMPOSTO) IN (SELECT DISTINCT N.CDFILIAL, N.NRLANCTONF, IP.CDIMPOSTO
                                                      FROM NOTAFISCAL N, CONTAPAGAR C, BOLETPAGAR B, BAIXAPAGA BX, IMPOSTONF IP
                                                     WHERE N.CDEMPRESA     = P_CDEMPRESA
                                                       AND N.IDSTATUS      IN ('A','E')
                                                       AND N.IDENTRSAIDOP  = 'E'
                                                       AND N.CDFILIAL      = C.CDFILIAL
                                                       AND N.NRLANCTONF    = C.NRLANCTONF
                                                       AND IP.CDFILIAL     = C.CDFILIAL
                                                       AND IP.NRLANCTONF   = C.NRLANCTONF
                                                       AND ((IP.CDIMPOSTO  IN (SELECT CDIMPOSTO FROM IMPOSTO
                                                                                WHERE CDIMPOSTONFE = P_CDIMPOSTO)) OR
                                                            (IP.CDIMPOSTO  IN (SELECT CDIMPOSTO FROM IMPOSTO
                                                                                WHERE CDIMPOSAPUR IN (SELECT CDIMPOSTO FROM IMPOSTO
                                                                                                       WHERE CDIMPOSTONFE = P_CDIMPOSTO))))
                                                       AND (((P_INSCRICAO IS NULL) AND (P_IDORGARRECADNFE = 'F' OR P_IDORGARRECADNFE IS NULL)) OR
                                                             (CDINSCESTA  = P_INSCRICAO AND P_IDORGARRECADNFE = 'E') OR
                                                             (CDINSCMUNI  = P_INSCRICAO AND P_IDORGARRECADNFE = 'M'))
                                                       AND C.CDFILIBPAG   = B.CDFILIAL
                                                       AND C.NRLANBOLPAG  = B.NRLANBOLPAG
                                                       AND B.CDFILIBAIPAG = BX.CDFILIAL
                                                       AND B.NRBAIXAPAG   = BX.NRBAIXAPAG
                                                       AND BX.CDEMPRESA   = P_CDEMPRESA
                                                       AND (((P_IDNFFORAPERAPU='N') AND (BX.DTBAIXAPAG BETWEEN P_DTININFFORPER AND P_DTFINAL)) OR
                                                            ((P_IDNFFORAPERAPU='S') AND (IP.DTREFMAPAPU IS NULL) AND (BX.DTBAIXAPAG BETWEEN P_DTININFFORPER AND P_DTFINAL)) OR
                                                            ((P_IDNFFORAPERAPU='S') AND (IP.DTREFMAPAPU BETWEEN P_DTINICIAL AND P_DTFINAL) AND (BX.DTBAIXAPAG BETWEEN P_DTININFFORPER AND P_DTFINAL))));

         UPDATE IMPOSTONF
            SET NRSEQUMAPAPU = P_NRSEQUMAPAPU
          WHERE NRSEQUMAPAPU IS NULL
            AND (CDFILIAL,NRLANCTONF,CDIMPOSTO) IN (SELECT DISTINCT N.CDFILIAL, N.NRLANCTONF, IP.CDIMPOSTO
                                                      FROM NOTAFISCAL N, CONTARECEBER C, BOLETRECEBER B, BAIXARECEBIDA BX, IMPOSTONF IP
                                                     WHERE N.CDEMPRESA     = P_CDEMPRESA
                                                       AND N.IDSTATUS      IN ('A','E')
                                                       AND N.IDENTRSAIDOP  = 'S'
                                                       AND N.CDFILIAL      = C.CDFILIAL
                                                       AND N.NRLANCTONF    = C.NRLANCTONF
                                                       AND IP.CDFILIAL     = C.CDFILIAL
                                                       AND IP.NRLANCTONF   = C.NRLANCTONF
                                                       AND ((IP.CDIMPOSTO  IN (SELECT CDIMPOSTO FROM IMPOSTO
                                                                                WHERE CDIMPOSTONFE = P_CDIMPOSTO)) OR
                                                            (IP.CDIMPOSTO  IN (SELECT CDIMPOSTO FROM IMPOSTO
                                                                                WHERE CDIMPOSAPUR IN (SELECT CDIMPOSTO FROM IMPOSTO
                                                                                                       WHERE CDIMPOSTONFE = P_CDIMPOSTO))))
                                                       AND (((P_INSCRICAO IS NULL)      AND (P_IDORGARRECADNFE = 'F'  OR P_IDORGARRECADNFE IS NULL)) OR
                                                             (CDINSCESTA  = P_INSCRICAO AND  P_IDORGARRECADNFE = 'E') OR
                                                             (CDINSCMUNI  = P_INSCRICAO AND  P_IDORGARRECADNFE = 'M'))
                                                       AND C.CDFILIBOLREC = B.CDFILIAL
                                                       AND C.NRLANBOLREC  = B.NRLANBOLREC
                                                       AND B.CDFILIBAIREC = BX.CDFILIAL
                                                       AND B.NRBAIXAREC   = BX.NRBAIXAREC
                                                       AND BX.CDEMPRESA   = P_CDEMPRESA
                                                       AND (((P_IDNFFORAPERAPU='N') AND (BX.DTBAIXAREC BETWEEN P_DTININFFORPER AND P_DTFINAL)) OR
                                                            ((P_IDNFFORAPERAPU='S') AND (IP.DTREFMAPAPU IS NULL) AND (BX.DTBAIXAREC BETWEEN P_DTININFFORPER AND P_DTFINAL)) OR
                                                            ((P_IDNFFORAPERAPU='S') AND (IP.DTREFMAPAPU BETWEEN P_DTINICIAL AND P_DTFINAL) AND (BX.DTBAIXAREC BETWEEN P_DTININFFORPER AND P_DTFINAL))));

      /******** Considera o valor do imposto proporcional ao valor da nota que foi pago - Dados na IMPBAIXAREC ********/
      ELSE
         UPDATE IMPBAIXAREC
            SET NRSEQUMAPAPU = P_NRSEQUMAPAPU
          WHERE NRSEQUMAPAPU IS NULL
            AND (CDFILIAL,NRLANCTONF,NRSEQUENCIAL,CDIMPOSTO) IN (SELECT DISTINCT N.CDFILIAL,N.NRLANCTONF,I.NRSEQUENCIAL,I.CDIMPOSTO
                                                                   FROM NOTAFISCAL N, IMPBAIXAREC I
                                                                  WHERE N.CDEMPRESA    = P_CDEMPRESA
                                                                    AND N.IDSTATUS     IN ('A','E')
                                                                    AND N.CDFILIAL     = I.CDFILIAL
                                                                    AND N.NRLANCTONF   = I.NRLANCTONF
                                                                    AND ((I.CDIMPOSTO IN (SELECT CDIMPOSTO FROM IMPOSTO
                                                                                           WHERE CDIMPOSTONFE = P_CDIMPOSTO)) OR
                                                                         (I.CDIMPOSTO IN (SELECT CDIMPOSTO FROM IMPOSTO
                                                                                           WHERE CDIMPOSAPUR IN (SELECT CDIMPOSTO FROM IMPOSTO
                                                                                                                  WHERE CDIMPOSTONFE = P_CDIMPOSTO))))
                                                                    AND (((P_INSCRICAO IS NULL) AND (P_IDORGARRECADNFE = 'F' OR P_IDORGARRECADNFE IS NULL)) OR
                                                                          (N.CDINSCESTA = P_INSCRICAO AND P_IDORGARRECADNFE = 'E') OR
                                                                          (N.CDINSCMUNI = P_INSCRICAO AND P_IDORGARRECADNFE = 'M'))
                                                                    AND (((P_IDNFFORAPERAPU='N') AND (I.DTBAIXAREC BETWEEN P_DTININFFORPER AND P_DTFINAL)) OR
                                                                         ((P_IDNFFORAPERAPU='S') AND (I.DTREFMAPAPU IS NULL) AND (I.DTBAIXAREC BETWEEN P_DTININFFORPER AND P_DTFINAL)) OR
                                                                         ((P_IDNFFORAPERAPU='S') AND (I.DTREFMAPAPU BETWEEN P_DTINICIAL AND P_DTFINAL) AND (I.DTBAIXAREC BETWEEN P_DTININFFORPER AND P_DTFINAL))));

      END IF;
   END IF;

   /******** Documentos Fora do Perodo ********/
   V_NFFORAPERIODO := 'N';
   BEGIN
      SELECT MAX('S') AS NFFORAPERIODO
        INTO V_NFFORAPERIODO
        FROM (SELECT IP.CDFILIAL, IP.NRLANCTONF
                FROM IMPOSTONF IP, CONTAPAGAR C, BOLETPAGAR B, BAIXAPAGA BX
               WHERE ((IP.NRSEQUMAPAPU = P_NRSEQUMAPAPU) OR
                      (IP.NRSEQMAPOIMP = P_NRSEQUMAPAPU))
                 AND IP.CDFILIAL       = C.CDFILIAL
                 AND IP.NRLANCTONF     = C.NRLANCTONF
                 AND C.CDFILIBPAG      = B.CDFILIAL
                 AND C.NRLANBOLPAG     = B.NRLANBOLPAG
                 AND B.CDFILIBAIPAG    = BX.CDFILIAL
                 AND B.NRBAIXAPAG      = BX.NRBAIXAPAG
                 AND BX.CDEMPRESA      = P_CDEMPRESA
                 AND BX.DTBAIXAPAG BETWEEN P_DTININFFORPER AND (P_DTINICIAL-1)
                 AND V_IDCONSVRIMPAG   = 'T'
               UNION ALL
              SELECT IP.CDFILIAL, IP.NRLANCTONF
                FROM IMPOSTONF IP, CONTARECEBER C, BOLETRECEBER B, BAIXARECEBIDA BX
               WHERE ((IP.NRSEQUMAPAPU = P_NRSEQUMAPAPU) OR
                      (IP.NRSEQMAPOIMP = P_NRSEQUMAPAPU))
                 AND IP.CDFILIAL       = C.CDFILIAL
                 AND IP.NRLANCTONF     = C.NRLANCTONF
                 AND C.CDFILIBOLREC    = B.CDFILIAL
                 AND C.NRLANBOLREC     = B.NRLANBOLREC
                 AND B.CDFILIBAIREC    = BX.CDFILIAL
                 AND B.NRBAIXAREC      = BX.NRBAIXAREC
                 AND BX.CDEMPRESA      = P_CDEMPRESA
                 AND BX.DTBAIXAREC BETWEEN P_DTININFFORPER AND (P_DTINICIAL-1)
                 AND V_IDCONSVRIMPAG   = 'T'
               UNION ALL
              SELECT IB.CDFILIAL, IB.NRLANCTONF
                FROM IMPBAIXAREC IB
               WHERE ((IB.NRSEQUMAPAPU = P_NRSEQUMAPAPU) OR
                      (IB.NRSEQMAPOIMP = P_NRSEQUMAPAPU))
                 AND IB.DTBAIXAREC BETWEEN P_DTININFFORPER AND (P_DTINICIAL-1)
                 AND V_IDCONSVRIMPAG = 'P');
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_NFFORAPERIODO := 'N';
   END;

   RETURN(V_IDAPURACAO || V_NFFORAPERIODO);
END;